import * as Promise from 'bluebird';
import { Query } from 'pretur.sync';
import { Model } from 'pretur.spec';
import { Pool } from './pool';
export interface ResolveResult<T> {
    data: T[];
    count?: number;
}
export interface Resolver<T> {
    (query: Query): Promise<ResolveResult<T>>;
}
export interface UnitializedResolver<T> {
    resolver: Resolver<T>;
    initialize(pool: Pool): void;
}
export declare function buildResolver<T>(spec: Model): UnitializedResolver<T>;
